package com.mysql.jdbc;

import java.io.ObjectInputStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.TimeZone;

/* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/Util.class */
public class Util {
    protected static Method systemNanoTimeMethod;
    private static Method CAST_METHOD;
    private static final TimeZone DEFAULT_TIMEZONE;
    private static Util enclosingInstance;
    private static boolean isJdbc4;
    private static boolean isColdFusion;
    static Class class$java$lang$System;
    static Class class$java$lang$Object;
    static Class class$java$lang$Class;

    static Class class$(String x0) {
        try {
            return Class.forName(x0);
        } catch (ClassNotFoundException x1) {
            throw new NoClassDefFoundError(x1.getMessage());
        }
    }

    static {
        Class cls;
        Class<?> cls2;
        Class cls3;
        try {
            if (class$java$lang$System == null) {
                cls3 = class$("java.lang.System");
                class$java$lang$System = cls3;
            } else {
                cls3 = class$java$lang$System;
            }
            systemNanoTimeMethod = cls3.getMethod("nanoTime", null);
        } catch (NoSuchMethodException e) {
            systemNanoTimeMethod = null;
        } catch (SecurityException e2) {
            systemNanoTimeMethod = null;
        }
        DEFAULT_TIMEZONE = TimeZone.getDefault();
        enclosingInstance = new Util();
        isJdbc4 = false;
        isColdFusion = false;
        try {
            if (class$java$lang$Class == null) {
                cls = class$("java.lang.Class");
                class$java$lang$Class = cls;
            } else {
                cls = class$java$lang$Class;
            }
            Class<?>[] clsArr = new Class[1];
            if (class$java$lang$Object == null) {
                cls2 = class$("java.lang.Object");
                class$java$lang$Object = cls2;
            } else {
                cls2 = class$java$lang$Object;
            }
            clsArr[0] = cls2;
            CAST_METHOD = cls.getMethod("cast", clsArr);
        } catch (Throwable th) {
        }
        try {
            Class.forName("java.sql.NClob");
            isJdbc4 = true;
        } catch (Throwable th2) {
            isJdbc4 = false;
        }
        String loadedFrom = stackTraceToString(new Throwable());
        if (loadedFrom != null) {
            isColdFusion = loadedFrom.indexOf("coldfusion") != -1;
        } else {
            isColdFusion = false;
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public static boolean nanoTimeAvailable() {
        return systemNanoTimeMethod != null;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public static final TimeZone getDefaultTimeZone() {
        return (TimeZone) DEFAULT_TIMEZONE.clone();
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    /* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/Util$RandStructcture.class */
    public class RandStructcture {
        long maxValue;
        double maxValueDbl;
        long seed1;
        long seed2;
        private final Util this$0;

        RandStructcture(Util this$0) {
            this.this$0 = this$0;
        }
    }

    public static boolean isJdbc4() {
        return isJdbc4;
    }

    public static boolean isColdFusion() {
        return isColdFusion;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public static String newCrypt(String password, String seed) {
        if (password == null || password.length() == 0) {
            return password;
        }
        long[] pw = newHash(seed);
        long[] msg = newHash(password);
        long seed1 = (pw[0] ^ msg[0]) % 1073741823;
        long seed2 = (pw[1] ^ msg[1]) % 1073741823;
        char[] chars = new char[seed.length()];
        for (int i = 0; i < seed.length(); i++) {
            seed1 = ((seed1 * 3) + seed2) % 1073741823;
            seed2 = ((seed1 + seed2) + 33) % 1073741823;
            double d = seed1 / 1073741823;
            byte b = (byte) Math.floor((d * 31.0d) + 64.0d);
            chars[i] = (char) b;
        }
        long seed12 = ((seed1 * 3) + seed2) % 1073741823;
        long j = ((seed12 + seed2) + 33) % 1073741823;
        double d2 = seed12 / 1073741823;
        byte b2 = (byte) Math.floor(d2 * 31.0d);
        for (int i2 = 0; i2 < seed.length(); i2++) {
            int i3 = i2;
            chars[i3] = (char) (chars[i3] ^ ((char) b2));
        }
        return new String(chars);
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public static long[] newHash(String password) {
        long nr = 1345345333;
        long add = 7;
        long nr2 = 305419889;
        for (int i = 0; i < password.length(); i++) {
            if (password.charAt(i) != ' ' && password.charAt(i) != '\t') {
                long tmp = 255 & password.charAt(i);
                nr ^= (((nr & 63) + add) * tmp) + (nr << 8);
                nr2 += (nr2 << 8) ^ nr;
                add += tmp;
            }
        }
        long[] result = {nr & 2147483647L, nr2 & 2147483647L};
        return result;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public static String oldCrypt(String password, String seed) {
        if (password == null || password.length() == 0) {
            return password;
        }
        long hp = oldHash(seed);
        long hm = oldHash(password);
        long nr = (hp ^ hm) % 33554431;
        long s1 = nr;
        long s2 = nr / 2;
        char[] chars = new char[seed.length()];
        for (int i = 0; i < seed.length(); i++) {
            s1 = ((s1 * 3) + s2) % 33554431;
            s2 = ((s1 + s2) + 33) % 33554431;
            double d = s1 / 33554431;
            byte b = (byte) Math.floor((d * 31.0d) + 64.0d);
            chars[i] = (char) b;
        }
        return new String(chars);
    }

    static long oldHash(String password) {
        long nr = 1345345333;
        long nr2 = 7;
        for (int i = 0; i < password.length(); i++) {
            if (password.charAt(i) != ' ' && password.charAt(i) != '\t') {
                long tmp = password.charAt(i);
                nr ^= (((nr & 63) + nr2) * tmp) + (nr << 8);
                nr2 += tmp;
            }
        }
        return nr & 2147483647L;
    }

    private static RandStructcture randomInit(long seed1, long seed2) {
        Util util = enclosingInstance;
        util.getClass();
        RandStructcture randStruct = new RandStructcture(util);
        randStruct.maxValue = 1073741823L;
        randStruct.maxValueDbl = randStruct.maxValue;
        randStruct.seed1 = seed1 % randStruct.maxValue;
        randStruct.seed2 = seed2 % randStruct.maxValue;
        return randStruct;
    }

    public static Object readObject(ResultSet resultSet, int index) throws Exception {
        ObjectInputStream objIn = new ObjectInputStream(resultSet.getBinaryStream(index));
        Object obj = objIn.readObject();
        objIn.close();
        return obj;
    }

    private static double rnd(RandStructcture randStruct) {
        randStruct.seed1 = ((randStruct.seed1 * 3) + randStruct.seed2) % randStruct.maxValue;
        randStruct.seed2 = ((randStruct.seed1 + randStruct.seed2) + 33) % randStruct.maxValue;
        return randStruct.seed1 / randStruct.maxValueDbl;
    }

    public static String scramble(String message, String password) {
        byte[] to = new byte[8];
        String val = "";
        String message2 = message.substring(0, 8);
        if (password != null && password.length() > 0) {
            long[] hashPass = newHash(password);
            long[] hashMessage = newHash(message2);
            RandStructcture randStruct = randomInit(hashPass[0] ^ hashMessage[0], hashPass[1] ^ hashMessage[1]);
            int msgPos = 0;
            int msgLength = message2.length();
            int toPos = 0;
            while (true) {
                int i = msgPos;
                msgPos++;
                if (i >= msgLength) {
                    break;
                }
                int i2 = toPos;
                toPos++;
                to[i2] = (byte) (Math.floor(rnd(randStruct) * 31.0d) + 64.0d);
            }
            byte extra = (byte) Math.floor(rnd(randStruct) * 31.0d);
            for (int i3 = 0; i3 < to.length; i3++) {
                int i4 = i3;
                to[i4] = (byte) (to[i4] ^ extra);
            }
            val = new String(to);
        }
        return val;
    }

    public static String stackTraceToString(Throwable ex) {
        StringBuffer traceBuf = new StringBuffer();
        traceBuf.append(Messages.getString("Util.1"));
        if (ex != null) {
            traceBuf.append(ex.getClass().getName());
            String message = ex.getMessage();
            if (message != null) {
                traceBuf.append(Messages.getString("Util.2"));
                traceBuf.append(message);
            }
            StringWriter out = new StringWriter();
            PrintWriter printOut = new PrintWriter(out);
            ex.printStackTrace(printOut);
            traceBuf.append(Messages.getString("Util.3"));
            traceBuf.append(out.toString());
        }
        traceBuf.append(Messages.getString("Util.4"));
        return traceBuf.toString();
    }

    public static Object getInstance(String className, Class[] argTypes, Object[] args) throws SQLException {
        try {
            return handleNewInstance(Class.forName(className).getConstructor(argTypes), args);
        } catch (ClassNotFoundException e) {
            throw SQLError.createSQLException("Can't instantiate required class", SQLError.SQL_STATE_GENERAL_ERROR, e);
        } catch (NoSuchMethodException e2) {
            throw SQLError.createSQLException("Can't instantiate required class", SQLError.SQL_STATE_GENERAL_ERROR, e2);
        } catch (SecurityException e3) {
            throw SQLError.createSQLException("Can't instantiate required class", SQLError.SQL_STATE_GENERAL_ERROR, e3);
        }
    }

    public static final Object handleNewInstance(Constructor ctor, Object[] args) throws SQLException {
        try {
            return ctor.newInstance(args);
        } catch (IllegalAccessException e) {
            throw SQLError.createSQLException("Can't instantiate required class", SQLError.SQL_STATE_GENERAL_ERROR, e);
        } catch (IllegalArgumentException e2) {
            throw SQLError.createSQLException("Can't instantiate required class", SQLError.SQL_STATE_GENERAL_ERROR, e2);
        } catch (InstantiationException e3) {
            throw SQLError.createSQLException("Can't instantiate required class", SQLError.SQL_STATE_GENERAL_ERROR, e3);
        } catch (InvocationTargetException e4) {
            Throwable target = e4.getTargetException();
            if (target instanceof SQLException) {
                throw ((SQLException) target);
            }
            if (target instanceof ExceptionInInitializerError) {
                target = ((ExceptionInInitializerError) target).getException();
            }
            throw SQLError.createSQLException(target.toString(), SQLError.SQL_STATE_GENERAL_ERROR);
        }
    }

    public static boolean interfaceExists(String hostname) {
        try {
            Class networkInterfaceClass = Class.forName("java.net.NetworkInterface");
            return networkInterfaceClass.getMethod("getByName", null).invoke(networkInterfaceClass, hostname) != null;
        } catch (Throwable th) {
            return false;
        }
    }

    public static Object cast(Object invokeOn, Object toCast) {
        if (CAST_METHOD != null) {
            try {
                return CAST_METHOD.invoke(invokeOn, toCast);
            } catch (Throwable th) {
                return null;
            }
        }
        return null;
    }

    public static long getCurrentTimeNanosOrMillis() {
        if (systemNanoTimeMethod != null) {
            try {
                return ((Long) systemNanoTimeMethod.invoke(null, null)).longValue();
            } catch (IllegalAccessException e) {
            } catch (IllegalArgumentException e2) {
            } catch (InvocationTargetException e3) {
            }
        }
        return System.currentTimeMillis();
    }

    public static void resultSetToMap(Map mappedValues, ResultSet rs) throws SQLException {
        while (rs.next()) {
            mappedValues.put(rs.getObject(1), rs.getObject(2));
        }
    }

    public static Map calculateDifferences(Map map1, Map map2) {
        Number value1;
        Number value2;
        Map diffMap = new HashMap();
        for (Map.Entry entry : map1.entrySet()) {
            Object key = entry.getKey();
            if (entry.getValue() instanceof Number) {
                value1 = (Number) entry.getValue();
                value2 = (Number) map2.get(key);
            } else {
                try {
                    value1 = new Double(entry.getValue().toString());
                    value2 = new Double(map2.get(key).toString());
                } catch (NumberFormatException e) {
                }
            }
            if (!value1.equals(value2)) {
                if (value1 instanceof Byte) {
                    diffMap.put(key, new Byte((byte) (((Byte) value2).byteValue() - ((Byte) value1).byteValue())));
                } else if (value1 instanceof Short) {
                    diffMap.put(key, new Short((short) (((Short) value2).shortValue() - ((Short) value1).shortValue())));
                } else if (value1 instanceof Integer) {
                    diffMap.put(key, new Integer(((Integer) value2).intValue() - ((Integer) value1).intValue()));
                } else if (value1 instanceof Long) {
                    diffMap.put(key, new Long(((Long) value2).longValue() - ((Long) value1).longValue()));
                } else if (value1 instanceof Float) {
                    diffMap.put(key, new Float(((Float) value2).floatValue() - ((Float) value1).floatValue()));
                } else if (value1 instanceof Double) {
                    diffMap.put(key, new Double(((Double) value2).shortValue() - ((Double) value1).shortValue()));
                } else if (value1 instanceof BigDecimal) {
                    diffMap.put(key, ((BigDecimal) value2).subtract((BigDecimal) value1));
                } else if (value1 instanceof BigInteger) {
                    diffMap.put(key, ((BigInteger) value2).subtract((BigInteger) value1));
                }
            }
        }
        return diffMap;
    }
}
